import java.util.*;

public class Solution {
    public static void main(String args[]) {
        Scanner input = new Scanner(System.in);
        ArrayList<Author> authors = new ArrayList<Author>();
        int authorCount = Integer.parseInt(input.nextLine());
        int authorId, bookId, bookYear, bookCount;
        String authorName, bookTitle, nationality;
        ArrayList<Book> books;

        for (int i = 0; i < authorCount; ++i) {
            authorId = Integer.parseInt(input.nextLine());
            authorName = input.nextLine();
            nationality = input.nextLine();

            bookCount = Integer.parseInt(input.nextLine());
            books = new ArrayList<Book>();

            for (int j = 0; j < bookCount; ++j) {
                bookId = Integer.parseInt(input.nextLine());
                bookTitle = input.nextLine();
                bookYear = Integer.parseInt(input.nextLine());
                books.add(new Book(bookId, bookTitle, bookYear));
            }

            authors.add(new Author(authorId, authorName, nationality, books));
        }

        int queryId = Integer.parseInt(input.nextLine());
        for (int year: getUniquePublishedYear(authors, queryId)) {
            System.out.println(year);
        }

        String qNation = input.nextLine();
        for (String bookName: getBooksByNationality(authors, qNation)) {
            System.out.println(bookName);
        }
    }

    private static TreeSet<Integer> getUniquePublishedYear(ArrayList<Author> authors, int queryId) {
        TreeSet<Integer> res = new TreeSet<>();

        for (Author author: authors) {
            if (author.id == queryId) {
                for (Book book: author.books) {
                    res.add(book.year);
                }
            }
        }

        return res;
    }

    private static ArrayList<String> getBooksByNationality(ArrayList<Author> authors, String qNation) {
        ArrayList<String> res = new ArrayList<>();

        for (Author author: authors) {
            if (author.nationality.equalsIgnoreCase(qNation)) {
                for (Book book: author.books) {
                    res.add(book.title);
                }
            }
        }

        return res;
    }
}

class Book {
    int id, year;
    String title;

    Book(int id, String title, int year) {
        this.id = id;
        this.title = title;
        this.year = year;
    }
}

class Author {
    int id;
    String name, nationality;
    ArrayList<Book> books;

    Author(int id, String name, String nationality, ArrayList<Book> books) {
        this.id = id;
        this.name = name;
        this.nationality = nationality;
        this.books = books;
    }
}
